% Exercise on ABCs : this is a possible start-from source % 

close all;

% computational domain
NX = 4096;
cx = linspace(0,NX-1,NX);

% parameters
la = 25;
k0 = 2.0/la;
w0 = 5.0*la;

% define initial electric field fucntion
InitialE = @(x,x0) sin(k0*x).*exp(-(x-x0).*(x-x0)/w0^2);

% choose time step
dtoverdx = 0.75;

% set initial conditions
xc = NX/2;
EF = +InitialE(cx,xc);

% you may want to modify this in order to check the proper
% ABC function at both boundaries - create pulses going both directions...
HF = -InitialE(cx - 0.5 -0.5*dtoverdx,xc);


% execute some steps
figure(1);
hold off;
for s=0:5000
EF = EF + dtoverdx*(circshift(HF,[1,-1]) - HF);
HF = HF - dtoverdx*(circshift(EF,[1,+1]) - EF);

% for now this is a PEC boundary
EF(1)  = 0;
HF(1)  = 0;
EF(NX) = 0;
HF(NX) = 0;

plot(cx,EF)
pause(0.001);

end


