(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     39893,       1246]
NotebookOptionsPosition[     38635,       1197]
NotebookOutlinePosition[     38972,       1212]
CellTagsIndexPosition[     38929,       1209]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"eqn1", " ", "=", " ", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"F", "[", 
     RowBox[{"0", ",", "1"}], "]"}]}], " ", "+", " ", 
   RowBox[{"F", "[", 
    RowBox[{"1", ",", "0"}], "]"}], " ", "+", " ", 
   RowBox[{"r", " ", 
    RowBox[{"(", " ", 
     RowBox[{
      RowBox[{"F", "[", 
       RowBox[{"1", ",", "1"}], "]"}], " ", "-", " ", 
      RowBox[{"F", "[", 
       RowBox[{"0", ",", "0"}], "]"}]}], ")"}], " "}]}]}]], "Input",
 CellChangeTimes->{{3.599996807762164*^9, 3.599996875217148*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"F", "[", 
    RowBox[{"0", ",", "1"}], "]"}]}], "+", 
  RowBox[{"F", "[", 
   RowBox[{"1", ",", "0"}], "]"}], "+", 
  RowBox[{"r", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"F", "[", 
       RowBox[{"0", ",", "0"}], "]"}]}], "+", 
     RowBox[{"F", "[", 
      RowBox[{"1", ",", "1"}], "]"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.59999687164235*^9, 3.599996875564925*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Ansatz", "[", 
   RowBox[{"x_", ",", "t_"}], "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"1", " ", 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "I"}], " ", "k", " ", "x"}], " ", "-", 
      RowBox[{"I", " ", "om", " ", "t"}]}], "]"}]}], " ", "+", " ", 
   RowBox[{"R", " ", 
    RowBox[{"Exp", "[", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"+", "I"}], " ", "k", " ", "x"}], " ", "-", " ", 
      RowBox[{"I", " ", "om", " ", "t"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.599996910076318*^9, 3.599996950279901*^9}, {
  3.599996986514167*^9, 3.599997000116357*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eqn2", " ", "=", " ", 
  RowBox[{"eqn1", "/.", 
   RowBox[{
    RowBox[{"F", "[", 
     RowBox[{"a_", ",", "b_"}], "]"}], " ", "\[Rule]", " ", 
    RowBox[{"Ansatz", "[", 
     RowBox[{"a", ",", "b"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.599996954019211*^9, 3.599997009449069*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["\[ExponentialE]", 
   RowBox[{
    RowBox[{"-", "\[ImaginaryI]"}], " ", "k"}]], "-", 
  SuperscriptBox["\[ExponentialE]", 
   RowBox[{
    RowBox[{"-", "\[ImaginaryI]"}], " ", "om"}]], "+", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"\[ImaginaryI]", " ", "k"}]], " ", "R"}], "-", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "\[ImaginaryI]"}], " ", "om"}]], " ", "R"}], "+", 
  RowBox[{"r", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "k"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "om"}]}]], "-", "R", "+", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"\[ImaginaryI]", " ", "k"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "om"}]}]], " ", "R"}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.599997011352906*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solR", " ", "=", " ", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{"eqn2", "\[Equal]", "0"}], ",", "R"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5999970168077383`*^9, 3.599997038417927*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"R", "\[Rule]", 
   FractionBox[
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "k"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"\[ImaginaryI]", " ", "k"}]], "-", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"\[ImaginaryI]", " ", "om"}]], "-", "r", "+", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"k", "+", "om"}], ")"}]}]], " ", "r"}]}], ")"}]}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"k", "+", "om"}], ")"}]}]], "+", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"\[ImaginaryI]", " ", "k"}]], " ", "r"}], "-", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"\[ImaginaryI]", " ", "om"}]], " ", "r"}]}]]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.5999970229455*^9, 3.5999970389782133`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"aux1", " ", "=", " ", 
  RowBox[{"Simplify", "[", 
   RowBox[{"ExpToTrig", "[", 
    RowBox[{"R", "/.", "solR"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.599997058111557*^9, 3.599997083010112*^9}, 
   3.599997253557604*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Cos", "[", "k", "]"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"Sin", "[", "k", "]"}]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Sin", "[", 
      FractionBox[
       RowBox[{"k", "-", "om"}], "2"], "]"}], "+", 
     RowBox[{"r", " ", 
      RowBox[{"Sin", "[", 
       FractionBox[
        RowBox[{"k", "+", "om"}], "2"], "]"}]}]}], ")"}]}], 
  RowBox[{
   RowBox[{"r", " ", 
    RowBox[{"Sin", "[", 
     FractionBox[
      RowBox[{"k", "-", "om"}], "2"], "]"}]}], "+", 
   RowBox[{"Sin", "[", 
    FractionBox[
     RowBox[{"k", "+", "om"}], "2"], "]"}]}]]], "Output",
 CellChangeTimes->{{3.599997063650823*^9, 3.599997083490561*^9}, 
   3.59999725427347*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"aux2", " ", "=", 
  RowBox[{"TrigExpand", "[", "aux", "]"}]}]], "Input",
 CellChangeTimes->{{3.5999971355453863`*^9, 3.599997149096778*^9}, {
  3.599997257413054*^9, 3.599997258796062*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"\[ImaginaryI]", " ", 
     RowBox[{"Cos", "[", 
      FractionBox["k", "2"], "]"}], " ", 
     RowBox[{"Cos", "[", 
      FractionBox["om", "2"], "]"}]}], 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         FractionBox["om", "2"], "]"}], " ", 
        RowBox[{"Sin", "[", 
         FractionBox["k", "2"], "]"}]}], "+", 
       RowBox[{"r", " ", 
        RowBox[{"Cos", "[", 
         FractionBox["om", "2"], "]"}], " ", 
        RowBox[{"Sin", "[", 
         FractionBox["k", "2"], "]"}]}], "+", 
       RowBox[{
        RowBox[{"Cos", "[", 
         FractionBox["k", "2"], "]"}], " ", 
        RowBox[{"Sin", "[", 
         FractionBox["om", "2"], "]"}]}], "-", 
       RowBox[{"r", " ", 
        RowBox[{"Cos", "[", 
         FractionBox["k", "2"], "]"}], " ", 
        RowBox[{"Sin", "[", 
         FractionBox["om", "2"], "]"}]}]}], ")"}]}]]}], "-", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", "r", " ", 
    RowBox[{"Cos", "[", 
     FractionBox["k", "2"], "]"}], " ", 
    RowBox[{"Cos", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    SuperscriptBox[
     RowBox[{"Cos", "[", 
      FractionBox["k", "2"], "]"}], "3"], " ", 
    RowBox[{"Cos", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", "r", " ", 
    SuperscriptBox[
     RowBox[{"Cos", "[", 
      FractionBox["k", "2"], "]"}], "3"], " ", 
    RowBox[{"Cos", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "-", 
  FractionBox[
   RowBox[{
    RowBox[{"Cos", "[", 
     FractionBox["om", "2"], "]"}], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["k", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "-", 
  FractionBox[
   RowBox[{"r", " ", 
    RowBox[{"Cos", "[", 
     FractionBox["om", "2"], "]"}], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["k", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"3", " ", 
    SuperscriptBox[
     RowBox[{"Cos", "[", 
      FractionBox["k", "2"], "]"}], "2"], " ", 
    RowBox[{"Cos", "[", 
     FractionBox["om", "2"], "]"}], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["k", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"3", " ", "r", " ", 
    SuperscriptBox[
     RowBox[{"Cos", "[", 
      FractionBox["k", "2"], "]"}], "2"], " ", 
    RowBox[{"Cos", "[", 
     FractionBox["om", "2"], "]"}], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["k", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "-", 
  FractionBox[
   RowBox[{"3", " ", "\[ImaginaryI]", " ", 
    RowBox[{"Cos", "[", 
     FractionBox["k", "2"], "]"}], " ", 
    RowBox[{"Cos", "[", 
     FractionBox["om", "2"], "]"}], " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", 
      FractionBox["k", "2"], "]"}], "2"]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "-", 
  FractionBox[
   RowBox[{"3", " ", "\[ImaginaryI]", " ", "r", " ", 
    RowBox[{"Cos", "[", 
     FractionBox["k", "2"], "]"}], " ", 
    RowBox[{"Cos", "[", 
     FractionBox["om", "2"], "]"}], " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", 
      FractionBox["k", "2"], "]"}], "2"]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "-", 
  FractionBox[
   RowBox[{
    RowBox[{"Cos", "[", 
     FractionBox["om", "2"], "]"}], " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", 
      FractionBox["k", "2"], "]"}], "3"]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "-", 
  FractionBox[
   RowBox[{"r", " ", 
    RowBox[{"Cos", "[", 
     FractionBox["om", "2"], "]"}], " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", 
      FractionBox["k", "2"], "]"}], "3"]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "-", 
  FractionBox[
   RowBox[{
    RowBox[{"Cos", "[", 
     FractionBox["k", "2"], "]"}], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"r", " ", 
    RowBox[{"Cos", "[", 
     FractionBox["k", "2"], "]"}], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "-", 
  FractionBox[
   RowBox[{
    SuperscriptBox[
     RowBox[{"Cos", "[", 
      FractionBox["k", "2"], "]"}], "3"], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"r", " ", 
    SuperscriptBox[
     RowBox[{"Cos", "[", 
      FractionBox["k", "2"], "]"}], "3"], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    RowBox[{"Sin", "[", 
     FractionBox["k", "2"], "]"}], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "-", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", "r", " ", 
    RowBox[{"Sin", "[", 
     FractionBox["k", "2"], "]"}], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"3", " ", "\[ImaginaryI]", " ", 
    SuperscriptBox[
     RowBox[{"Cos", "[", 
      FractionBox["k", "2"], "]"}], "2"], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["k", "2"], "]"}], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "-", 
  FractionBox[
   RowBox[{"3", " ", "\[ImaginaryI]", " ", "r", " ", 
    SuperscriptBox[
     RowBox[{"Cos", "[", 
      FractionBox["k", "2"], "]"}], "2"], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["k", "2"], "]"}], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"Cos", "[", 
     FractionBox["k", "2"], "]"}], " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", 
      FractionBox["k", "2"], "]"}], "2"], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "-", 
  FractionBox[
   RowBox[{"3", " ", "r", " ", 
    RowBox[{"Cos", "[", 
     FractionBox["k", "2"], "]"}], " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", 
      FractionBox["k", "2"], "]"}], "2"], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "-", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", 
      FractionBox["k", "2"], "]"}], "3"], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", "r", " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", 
      FractionBox["k", "2"], "]"}], "3"], " ", 
    RowBox[{"Sin", "[", 
     FractionBox["om", "2"], "]"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["om", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["k", "2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}], "-", 
      RowBox[{"r", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["k", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["om", "2"], "]"}]}]}], ")"}]}]]}]], "Output",
 CellChangeTimes->{{3.599997139351017*^9, 3.599997149571175*^9}, 
   3.599997259407628*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"aux3", " ", "=", " ", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"aux2", "/.", 
      RowBox[{
       RowBox[{"Cos", "[", 
        RowBox[{"om", "/", "2"}], "]"}], "\[Rule]", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"1", "-", 
         RowBox[{
          RowBox[{"Sin", "[", 
           RowBox[{"om", "/", "2"}], "]"}], "^", "2"}]}], "]"}]}]}], ")"}], "/.", 
    RowBox[{
     RowBox[{"Sin", "[", 
      RowBox[{"om", "/", "2"}], "]"}], "\[Rule]", " ", 
     RowBox[{"dtoverdx", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"k", "/", "2"}], "]"}]}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5999972669245653`*^9, 3.5999973416155148`*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "dtoverdx", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "r"}], ")"}], " ", 
      RowBox[{"Cos", "[", 
       FractionBox["k", "2"], "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "r"}], ")"}], " ", 
      SqrtBox[
       RowBox[{"4", "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["dtoverdx", "2"]}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["dtoverdx", "2"], " ", 
         RowBox[{"Cos", "[", "k", "]"}]}]}]]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Cos", "[", "k", "]"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"Sin", "[", "k", "]"}]}]}], ")"}]}], 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "dtoverdx"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "r"}], ")"}], " ", 
      RowBox[{"Cos", "[", 
       FractionBox["k", "2"], "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "r"}], ")"}], " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        RowBox[{
         SuperscriptBox["dtoverdx", "2"], " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", 
           FractionBox["k", "2"], "]"}], "2"]}]}]]}]}], ")"}]}]]], "Output",
 CellChangeTimes->{{3.599997313494767*^9, 3.5999973422380657`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"check0", " ", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"Simplify", "[", 
     RowBox[{"aux3", "/.", 
      RowBox[{"k", "\[Rule]", "0"}]}], "]"}], "/.", 
    RowBox[{"r", "\[Rule]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"dtoverdx", " ", "-", "1"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"dtoverdx", " ", "+", "1"}], ")"}]}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.599997377980961*^9, 3.59999743841426*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.599997381142288*^9, 3.599997438811829*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"aux4", " ", "=", " ", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"aux3", "/.", 
      RowBox[{"k", "\[Rule]", " ", 
       RowBox[{"2", " ", 
        RowBox[{"Pi", "/", "n"}]}]}]}], ")"}], "/.", 
    RowBox[{"r", "\[Rule]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"dtoverdx", " ", "-", "1"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"dtoverdx", " ", "+", "1"}], ")"}]}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.599997443205512*^9, 3.5999974913762903`*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{"Cos", "[", 
       FractionBox["\[Pi]", "n"], "]"}]}], "+", 
     SqrtBox[
      RowBox[{"4", "-", 
       RowBox[{"2", " ", 
        SuperscriptBox["dtoverdx", "2"]}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["dtoverdx", "2"], " ", 
        RowBox[{"Cos", "[", 
         FractionBox[
          RowBox[{"2", " ", "\[Pi]"}], "n"], "]"}]}]}]]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Cos", "[", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]"}], "n"], "]"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"Sin", "[", 
       FractionBox[
        RowBox[{"2", " ", "\[Pi]"}], "n"], "]"}]}]}], ")"}]}], 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Cos", "[", 
      FractionBox["\[Pi]", "n"], "]"}], "+", 
     SqrtBox[
      RowBox[{"1", "-", 
       RowBox[{
        SuperscriptBox["dtoverdx", "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", 
          FractionBox["\[Pi]", "n"], "]"}], "2"]}]}]]}], ")"}]}]]], "Output",
 CellChangeTimes->{{3.599997465007462*^9, 3.59999749179526*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Abs", "[", 
    RowBox[{"aux4", "/.", 
     RowBox[{"dtoverdx", "\[Rule]", "0.25"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "2", ",", "15"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.599997500647455*^9, 3.5999975356544113`*^9}, {
  3.599997591075799*^9, 3.599997637995578*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVVWk0FAwbHWMb6zCRlEh2Y5heIqXveSSJkCylpLeFQnhLi9BbkkER2UVE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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{2., 0},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.5999975227929583`*^9, 3.599997535950185*^9}, {
  3.599997597015251*^9, 3.599997638504822*^9}}]
}, Open  ]]
},
WindowSize->{844, 899},
WindowMargins->{{399, Automatic}, {Automatic, 23}},
FrontEndVersion->"8.0 for Linux x86 (64-bit) (October 10, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 525, 15, 29, "Input"],
Cell[1107, 39, 460, 15, 29, "Output"]
}, Open  ]],
Cell[1582, 57, 647, 18, 29, "Input"],
Cell[CellGroupData[{
Cell[2254, 79, 314, 8, 29, "Input"],
Cell[2571, 89, 1001, 30, 34, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3609, 124, 316, 8, 29, "Input"],
Cell[3928, 134, 1139, 32, 51, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5104, 171, 255, 6, 29, "Input"],
Cell[5362, 179, 780, 26, 66, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6179, 210, 213, 4, 29, "Input"],
Cell[6395, 216, 22993, 732, 1508, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29425, 953, 703, 20, 29, "Input"],
Cell[30131, 975, 1417, 46, 94, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31585, 1026, 475, 13, 29, "Input"],
Cell[32063, 1041, 94, 1, 29, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32194, 1047, 532, 15, 29, "Input"],
Cell[32729, 1064, 1199, 39, 105, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33965, 1108, 409, 10, 29, "Input"],
Cell[34377, 1120, 4242, 74, 239, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

